#-----------------------------------------------------------------------------
%{?!dist:	%define	dist	.ok}
%define			docvers	6.0

#-----------------------------------------------------------------------------
Name		:	webkitgtk
Version		:	2.44.0
Release		:	16.2.0.rel%{?dist}
Summary		:	A portable web rendering engine
Group		:	Development/Libraries

Packager	:	Osukiss Project	<build-ok@osukiss.org>

License		:	LGPLv2
URL		:	https://webkitgtk.org/releases/

Source0		:	%{name}-%{version}.tar.xz

#-----------------------------------------------------------------------------
BuildRequires	:	at-spi2-core-devel
BuildRequires	:	cairo-devel
BuildRequires	:	cmake				>= 3.26.3
BuildRequires	:	docbook-xsl
BuildRequires	:	elogind-devel
BuildRequires	:	gobject-introspection
BuildRequires	:	gstreamer			=> 1.22.2
BuildRequires	:	gst-plugins-base		=> 1.22.2
BuildRequires	:	gst-plugins-bad			=> 1.22.2
BuildRequires	:	gtk-devel			=> 4.11.0
BuildRequires	:	icu
BuildRequires	:	lcms2
BuildRequires	:	libgudev
BuildRequires	:	libnotify
BuildRequires	:	libsoup
BuildRequires	:	libsoup2
BuildRequires	:	libsecret
BuildRequires	:	libtasn1-devel
BuildRequires	:	libxslt
BuildRequires	:	libwebp
BuildRequires	:	mesa-devel
BuildRequires	:	ninja
BuildRequires	:	openjpeg
BuildRequires	:	ruby
BuildRequires	:	unifdef			>=  2.12
BuildRequires	:	sqlite
BuildRequires	:	xorg-libXcomposite
BuildRequires	:	xorg-libXt
BuildRequires	:	wayland-protocols
BuildRequires	:	which
#-----------------------------------------------------------------------------
%description
'%{name}' is a port of the portable web rendering engine WebKit
to the GTK+-4 and  libsoup-3

#-----------------------------------------------------------------------------
%files			-f WebKitGTK-6.0.lang
%defattr(-,root,root,-)
%doc NEWS
%{_bindir}/WebKitWebDriver
%{_libdir}/girepository-1.0/*.typelib
%{_libdir}/lib*-6.0.so.*
%{_libdir}/webkitgtk-6.0/injected-bundle/lib*.so
%{_libexecdir}/webkitgtk-6.0/jsc
%{_libexecdir}/webkitgtk-6.0/MiniBrowser
%{_libexecdir}/webkitgtk-6.0/WebKitNetworkProcess
%{_libexecdir}/webkitgtk-6.0/WebKitWebProcess
%{_datadir}/gtk-doc/html/jsc-glib-%{docvers}/*.css
%{_datadir}/gtk-doc/html/jsc-glib-%{docvers}/*.{html,png}
%{_datadir}/gtk-doc/html/jsc-glib-%{docvers}/*.js
%{_datadir}/gtk-doc/html/jsc-glib-%{docvers}/index.json
%{_datadir}/gtk-doc/html/jsc-glib-%{docvers}/*.devhelp2
%{_datadir}/gtk-doc/html/jsc-glib-%{docvers}/*.{woff,woff2}
%{_datadir}/gtk-doc/html/webkitgtk-%{docvers}/*.{html,png}
%{_datadir}/gtk-doc/html/webkitgtk-%{docvers}/*.css
%{_datadir}/gtk-doc/html/webkitgtk-%{docvers}/*.{js,json}
%{_datadir}/gtk-doc/html/webkitgtk-%{docvers}/*.{woff,woff2}
%{_datadir}/gtk-doc/html/webkitgtk-%{docvers}/*.devhelp2
%{_datadir}/gtk-doc/html/webkitgtk-web-process-extension-%{docvers}/*.{html,png}
%{_datadir}/gtk-doc/html/webkitgtk-web-process-extension-%{docvers}/*.css
%{_datadir}/gtk-doc/html/webkitgtk-web-process-extension-%{docvers}/*.{woff,woff2}
%{_datadir}/gtk-doc/html/webkitgtk-web-process-extension-%{docvers}/*.js
%{_datadir}/gtk-doc/html/webkitgtk-web-process-extension-%{docvers}/index.json
%{_datadir}/gtk-doc/html/webkitgtk-web-process-extension-%{docvers}/*.devhelp2

#=============================================================================
%package		devel
Summary		:	Development files for webkitgtk6.0
	
#-----------------------------------------------------------------------------
Requires	:	%{name} = %{version}-%{release}
#-----------------------------------------------------------------------------
%description		devel
The webkitgtk6.0-devel package contains libraries,
build data, and header files for developing
applications that use webkitgtk6.0.

#-----------------------------------------------------------------------------
%files			devel
%defattr(-,root,root,-)
%{_includedir}/%{name}-6.0/*/*.h
%{_libexecdir}/webkitgtk-6.0/MiniBrowser
%{_libdir}/libwebkitgtk-6.0.so
%{_libdir}/libjavascriptcoregtk-6.0.so
%{_libdir}/pkgconfig/webkitgtk-6.0.pc
%{_libdir}/pkgconfig/webkitgtk-web-process-extension-6.0.pc
%{_libdir}/pkgconfig/javascriptcoregtk-6.0.pc
%{_datadir}/gir-1.0/WebKit-6.0.gir
%{_datadir}/gir-1.0/WebKitWebProcessExtension-6.0.gir
%{_datadir}/gir-1.0/JavaScriptCore-6.0.gir

#=============================================================================
%package		-n webkit2gtk4.1
Summary		:	WebKitGTK for GTK 3 and libsoup 3
	
#-----------------------------------------------------------------------------

#-----------------------------------------------------------------------------
%description		-n webkit2gtk4.1
WebKitGTK is the port of the WebKit web rendering
engine to the GTK platform. This package contains
WebKitGTK for GTK 3 and libsoup 3.

#-----------------------------------------------------------------------------
%files			-n webkit2gtk4.1 -f WebKitGTK-4.1.lang
%defattr(-,root,root,-)
%{_libdir}/libwebkit2gtk-4.1.so.0*
%{_libdir}/libjavascriptcoregtk-4.1.so.*
%{_libdir}/girepository-1.0/WebKit2-4.1.typelib
%{_libdir}/girepository-1.0/WebKit2WebExtension-4.1.typelib
%{_libdir}/webkit2gtk-4.1/injected-bundle/libwebkit2gtkinjectedbundle.so
%{_libexecdir}/webkit2gtk-4.1/jsc
%{_libexecdir}/webkit2gtk-4.1/MiniBrowser
%{_libexecdir}/webkit2gtk-4.1/WebKitNetworkProcess
%{_libexecdir}/webkit2gtk-4.1/WebKitWebProcess

#=============================================================================
%package		-n webkit2gtk4.1-devel
Summary		:	Development files for webkit2gtk4.1
	
#-----------------------------------------------------------------------------
Requires	:	webkit2gtk4.1 = %{version}-%{release}
#-----------------------------------------------------------------------------
%description		-n webkit2gtk4.1-devel
The webkit2gtk4.1-devel package contains libraries,
build data, and header files for developing
applications that use webkit2gtk4.1.
#-----------------------------------------------------------------------------
%files			-n webkit2gtk4.1-devel
%defattr(-,root,root,-)
%{_includedir}/webkitgtk-4.1/JavaScriptCore/*.h
%{_includedir}/webkitgtk-4.1/jsc/*.h
%{_includedir}/webkitgtk-4.1/webkit/*.h
%{_includedir}/webkitgtk-4.1/webkit2/*.h
%{_includedir}/webkitgtk-4.1/webkitdom/*.h
%{_libdir}/libwebkit2gtk-4.1.so
%{_libdir}/libjavascriptcoregtk-4.1.so
%{_libdir}/pkgconfig/webkit2gtk-4.1.pc
%{_libdir}/pkgconfig/webkit2gtk-web-extension-4.1.pc
%{_libdir}/pkgconfig/javascriptcoregtk-4.1.pc
%{_datadir}/gir-1.0/WebKit2-4.1.gir
%{_datadir}/gir-1.0/WebKit2WebExtension-4.1.gir
%{_datadir}/gir-1.0/JavaScriptCore-4.1.gir


#=============================================================================
%package		-n webkit2gtk4.0
Summary		:	 Development files for webkit2gtk4.0
	
#-----------------------------------------------------------------------------

#-----------------------------------------------------------------------------
%description		-n webkit2gtk4.0
WebKitGTK is the port of the WebKit web rendering
engine to the GTK platform. This package contains
WebKitGTK for GTK 3 and libsoup 2.

#-----------------------------------------------------------------------------
%files			-n webkit2gtk4.0 -f WebKitGTK-4.0.lang
%defattr(-,root,root,-)
%{_libdir}/libwebkit2gtk-4.0.so.37*
%{_libdir}/libjavascriptcoregtk-4.0.so.18*
%{_libdir}/girepository-1.0/WebKit2-4.0.typelib
%{_libdir}/girepository-1.0/WebKit2WebExtension-4.0.typelib
%{_libdir}/webkit2gtk-4.0/injected-bundle/libwebkit2gtkinjectedbundle.so
%{_libexecdir}/webkit2gtk-4.0/jsc
%{_libexecdir}/webkit2gtk-4.0/MiniBrowser
%{_libexecdir}/webkit2gtk-4.0/WebKitNetworkProcess
%{_libexecdir}/webkit2gtk-4.0/WebKitWebProcess

#=============================================================================
%package		-n webkit2gtk4.0-devel
Summary		:	Development files for webkit2gtk4.0
	
#-----------------------------------------------------------------------------
Requires	:	webkit2gtk4.0 = %{version}-%{release}
#-----------------------------------------------------------------------------
%description		-n webkit2gtk4.0-devel
The webkit2gtk4.1-devel package contains libraries,
build data, and header files for developing
applications that use webkit2gtk4.0.
#-----------------------------------------------------------------------------
%files			-n webkit2gtk4.0-devel
%defattr(-,root,root,-)
%{_includedir}/webkitgtk-4.0/JavaScriptCore
%{_includedir}/webkitgtk-4.0/jsc/*.h
%{_includedir}/webkitgtk-4.0/webkit/*.h
%{_includedir}/webkitgtk-4.0/webkit2/*.h
%{_includedir}/webkitgtk-4.0/webkitdom/*.h
%{_libdir}/libjavascriptcoregtk-4.0.so
%{_libdir}/libwebkit2gtk-4.0.so
%{_libdir}/pkgconfig/webkit2gtk-4.0.pc
%{_libdir}/pkgconfig/javascriptcoregtk-4.0.pc
%{_libdir}/pkgconfig/webkit2gtk-web-extension-4.0.pc
%{_datadir}/gir-1.0/WebKit2-4.0.gir
%{_datadir}/gir-1.0/WebKit2WebExtension-4.0.gir
%{_datadir}/gir-1.0/JavaScriptCore-4.0.gir


#=============================================================================
%prep
%setup -q

#-----------------------------------------------------------------------------
#building application
%build

#to prepare build of webgit-6.0
CFLAGS=-Wno-expansion-to-defined			\
CXXFLAGS=-Wno-expansion-to-defined			\
cmake							\
	-S .						\
	-B _bld_gtk-6.0					\
	-G Ninja					\
	-D CMAKE_BUILD_TYPE=Release			\
	-D CMAKE_INSTALL_PREFIX=%{_prefix}		\
	-D LIB_INSTALL_DIR=%{_libdir}			\
	-D CMAKE_SKIP_RPATH=ON				\
	-D PORT=GTK					\
	-D USE_LIBHYPHEN=OFF				\
	-D ENABLE_GAMEPAD=OFF				\
	-D ENABLE_MINIBROWSER=ON			\
	-D ENABLE_GEOLOCATION=OFF			\
	-D ENABLE_SPELLCHECK=OFF			\
	-D ENABLE_INTROSPECTION=ON			\
	-D ENABLE_WAYLAND_TARGET=OFF			\
	-D USER_AGENT_BRANDING="Osukiss" 		\
	-D USE_AVIF=OFF 				\
	-D USE_GSTREAMER_TRANSCODER=OFF	 		\
	-D USE_GTK4=ON	 				\
	-D USE_WOFF2=OFF				\
	-D USE_SOUP2=OFF 				\
	-D USE_JPEGXL=OFF				\
	-D USE_WPE_RENDERER=OFF 			\
	-D USE_SYSTEM_MALLOC=ON 			\
	-D ENABLE_DOCUMENTATION=OFF			\
	-D ENABLE_JOURNALD_LOG=OFF 			\
	-D ENABLE_BUBBLEWRAP_SANDBOX=OFF		\
	-D USE_LIBBACKTRACE=OFF				\
	-Wno-dev					\

cmake							\
	-S .						\
	-B _bld_gtk-4.1					\
	-G Ninja					\
	-D CMAKE_BUILD_TYPE=Release			\
	-D CMAKE_INSTALL_PREFIX=%{_prefix}		\
	-D LIB_INSTALL_DIR=%{_libdir}			\
	-D CMAKE_SKIP_RPATH=ON				\
	-D PORT=GTK					\
	-D USE_LIBHYPHEN=OFF				\
	-D ENABLE_GAMEPAD=OFF				\
	-D ENABLE_MINIBROWSER=ON			\
	-D ENABLE_GEOLOCATION=OFF			\
	-D ENABLE_SPELLCHECK=OFF			\
	-D ENABLE_INTROSPECTION=ON			\
	-D ENABLE_WAYLAND_TARGET=OFF			\
	-D USER_AGENT_BRANDING="Osukiss" 		\
	-D USE_AVIF=OFF 				\
	-D USE_GSTREAMER_TRANSCODER=OFF	 		\
	-D USE_GTK4=OFF	 				\
	-D USE_WOFF2=OFF				\
	-D USE_SOUP2=OFF 				\
	-D USE_JPEGXL=OFF				\
	-D USE_WPE_RENDERER=OFF 			\
	-D USE_SYSTEM_MALLOC=ON 			\
	-D ENABLE_DOCUMENTATION=OFF			\
	-D ENABLE_JOURNALD_LOG=OFF 			\
	-D ENABLE_BUBBLEWRAP_SANDBOX=OFF		\
	-D USE_LIBBACKTRACE=OFF				\
	-Wno-dev					\

cmake							\
	-S .						\
	-B _bld_gtk-4.0					\
	-G Ninja					\
	-D CMAKE_BUILD_TYPE=Release			\
	-D CMAKE_INSTALL_PREFIX=%{_prefix}		\
	-D LIB_INSTALL_DIR=%{_libdir}			\
	-D CMAKE_SKIP_RPATH=ON				\
	-D PORT=GTK					\
	-D USE_LIBHYPHEN=OFF				\
	-D ENABLE_GAMEPAD=OFF				\
	-D ENABLE_MINIBROWSER=ON			\
	-D ENABLE_GEOLOCATION=OFF			\
	-D ENABLE_SPELLCHECK=OFF			\
	-D ENABLE_INTROSPECTION=ON			\
	-D ENABLE_WAYLAND_TARGET=OFF			\
	-D USER_AGENT_BRANDING="Osukiss" 		\
	-D USE_AVIF=OFF 				\
	-D USE_GSTREAMER_TRANSCODER=OFF	 		\
	-D USE_GTK4=OFF	 				\
	-D USE_WOFF2=OFF				\
	-D USE_SOUP2=ON 				\
	-D USE_JPEGXL=OFF				\
	-D USE_WPE_RENDERER=OFF 			\
	-D USE_SYSTEM_MALLOC=ON 			\
	-D ENABLE_DOCUMENTATION=OFF			\
	-D ENABLE_JOURNALD_LOG=OFF 			\
	-D ENABLE_BUBBLEWRAP_SANDBOX=OFF		\
	-D USE_LIBBACKTRACE=OFF				\
	-Wno-dev					\

#Preparing a small Makefile
%define _smp_mflags -j%(/usr/bin/getconf _NPROCESSORS_ONLN)
%define _smp_mflags -j10
cat >> Makefile << "EOF"
#-------------------------------------------
gtk-6.0		:
	  ninja -C _bld_gtk-6.0		-k1 %{_smp_mflags}

gtk-4.1		:
	  ninja -C _bld_gtk-4.1		-k1 %{_smp_mflags}

gtk-4.0		:
	  ninja -C _bld_gtk-4.0		-k1 %{_smp_mflags}

#-------------------------------------------
EOF
#compiling both version
%{__make}						\
	-j 3						\
	gtk-6.0						\
	gtk-4.1						\
	gtk-4.0

#-----------------------------------------------------------------------------
%clean
%{__rm} -rf %{buildroot}

#-----------------------------------------------------------------------------
#installing program
%install
%{__rm} -rf %{buildroot}

install -vdm755 					\
	%{buildroot}%{_datadir}/gtk-doc/html/

for ver in						\
	6.0						\
	4.1						\
	4.0
  do
  pushd _bld_gtk-$ver
    DESTDIR=%{buildroot}				\
    ninja						\
		install
  popd
  done

pushd	Documentation
for doc in						\
  jsc-glib-%{docvers}					\
  webkitgtk-%{docvers}					\
  webkitgtk-web-process-extension-%{docvers}
  do
    %{__cp} -a						\
	$doc						\
	%{buildroot}%{_datadir}/gtk-doc/html/
   done
popd

%find_lang WebKitGTK-4.0
%find_lang WebKitGTK-4.1
%find_lang WebKitGTK-6.0

#-----------------------------------------------------------------------------
%changelog
